import java.awt.*;

public class Axis2D {
	private Transformation2d trans = new Transformation2d();	// WϊNX
	private int frame_w, frame_h;		// t[TCY
	private int grid_x, grid_y;		// OtBbNW̃ObhTCY
	private int origin_x, origin_y;		// OtBbNW̌_̈ʒu
	private double scale_x, scale_y;	// wW̃Obh̃TCY

	// 
	//  fw : t[̕(pixel) 
	//  fh : t[̍(pixel) 
	//  ox : OtBbNW̌_ẍʒu(pixel) 
	//  oy : OtBbNW̌_ÿʒu(pixel) 
	//  gx : OtBbNW̃Obh̕(pixel) 
	//  gy : OtBbNW̃Obh̍(pixel) 
	//  sx : wW̃Obh̕
	//  sy : wW̃Obh̍
	public boolean init( int fw, int fh, int ox, int oy, int gx, int gy, double sx, double sy )
	{
		// OtBbNW̃Obh̑傫`FbN
		if ( 1 > gx ) return false;
		if ( 1 > gy ) return false;

		// wWOtBbNW֕ϊIuWFNgtrans쐬
		//   ( 0.0, 0.0 )  ( ox, oy )A( sx, sy )  ( ox + gx, oy + gy )ƂȂ悤Ƀp[^[w
		if ( !trans.set( 0.0, 0.0, sx, sy, (double)ox, (double)oy, (double)( ox + gx ), (double)( oy + gy ) ) ) return false;

		// t[TCYoϐɑ
		frame_w = fw;
		frame_h = fh;

		// OtBbŇ_Woϐɑ
		origin_x = ox;
		origin_y = oy;

		// OtBbNW̃ObhTCYoϐɑ
		grid_x = gx;
		grid_y = gy;

		// wW̃ObhTCYoϐɑ
		scale_x = sx;
		scale_y = sy;

		return true;
	}


	// ObhxyW`
	//  g : Graphics IuWFNg 
	//  axiscolor : `悷xyW̐F
	//  gridcolor : `悷Obh̐F
	public void draw_grid( Graphics g, Color axiscolor, Color gridcolor )
	{
		// ̐Fݒ
		g.setColor( gridcolor );

		// ỹObh()`
		for ( int y = origin_y - grid_y; y >= 0; y -= grid_y )
			g.drawLine( 0, y, frame_w - 1, y );

		// y艺̃Obh()`
		for ( int y = origin_y + grid_y; y < frame_h; y += grid_y )
			g.drawLine( 0, y, frame_w - 1, y );

		// x荶̃Obh()`
		for ( int x = origin_x - grid_x; x >= 0; x -= grid_x )
			g.drawLine( x, 0, x, frame_h - 1 );

		// xẼObh()`
		for ( int x = origin_x + grid_x; x < frame_w; x += grid_x )
			g.drawLine( x, 0, x, frame_h - 1 );

		// W̕`
		// W̐Fݒ
		g.setColor( axiscolor );

		// x̕`
		g.drawLine( 0, origin_y, frame_w - 1, origin_y );

		// y̕`
		g.drawLine( origin_x, 0, origin_x, frame_h - 1 );
	}


	// hԂ~̕`
	//  g : Graphics IuWFNg 
	//  x : wW̉~̒SWx
	//  y : wW̉~̒SWy
	//  radius : OtBbNW̉~̔a
	//  color : F
	public void draw_fillcircle( Graphics g, double x, double y, int radius, Color col )
	{
		// OtBbNWi[ϐ
		int vx, vy;

		// F̐ݒ
		g.setColor( col );

		// wWOtBbNW֕ϊ
		vx = (int)( trans.getX( x ) - (double)radius );
		vy = (int)( trans.getY( y ) - (double)radius );

		//@hԂ~̕`
		g.fillOval( vx, vy, radius * 2 + 1, radius * 2 + 1 ); 
	}


	// ̕` 1
	//  g : Graphics IuWFNg 
	//  x1 : wW̍Wx1
	//  y1 : wW̍Wy1
	//  x2 : wW̍Wx2
	//  y2 : wW̍Wy2
	//  color : F
	public void draw_line( Graphics g, double x1, double y1, double x2, double y2, Color col )
	{
		// OtBbNWi[ϐ
		int vx1, vy1;
		int vx2, vy2;

		// F̐ݒ
		g.setColor( col );

		// wWOtBbNW֕ϊ
		vx1 = (int)trans.getX( x1 );
		vy1 = (int)trans.getY( y1 );
		vx2 = (int)trans.getX( x2 );
		vy2 = (int)trans.getY( y2 );

		//@̕`
		g.drawLine( vx1, vy1, vx2, vy2 ); 
	}
}